from zope.site.interfaces import IFolder
from zope.schema import TextLine
from zope.schema import Text
from zope.container.interfaces import IContainer
from zope.container.interfaces import IContained
from zope.schema import Field
from zope.container.constraints import ContainerTypesConstraint
from zope.container.constraints import ItemTypePrecondition

class ITicket(IContainer):
    """Ticket - the ticket content component"""

    number = TextLine(
        title=u"Number",
        description=u"Ticket number",
        default=u"",
        required=True)

    summary = Text(
        title=u"Summary",
        description=u"Ticket summary",
        default=u"",
        required=True)

class ICollector(IFolder):
    """The main application container"""

    name = TextLine(
        title=u"Name",
        description=u"Name of application container",
        default=u"",
        required=True)

    description = Text(
        title=u"Description",
        description=u"Description of application container",
        default=u"",
        required=False)


    def __setitem__(name, object):
        """Add an ICollector object."""

    __setitem__.precondition = ItemTypePrecondition(ITicket)


class ITicketContained(IContained):
    """Interface that specifies the type of objects that can contain
    tickets.  So a ticket can only contain in a collector."""

    __parent__ = Field(
        constraint = ContainerTypesConstraint(ICollector))

