from zope.site import LocalSiteManager
from zope.formlib import form
from zope.browserpage import ViewPageTemplateFile
from zope.container.interfaces import INameChooser

from tc.collector.interfaces import ICollector
from tc.collector.ticketcollector import Collector

from tc.collector.interfaces import ITicket
from tc.collector.ticket import Ticket

from tc.collector.interfaces import IComment
from tc.collector.comment import Comment

class AddTicketCollector(form.AddForm):

    form_fields = form.Fields(ICollector)

    def createAndAdd(self, data):
        name = data['name']
        description = data.get('description', u'')
        collector = Collector()
        collector.name = name
        collector.description = description
        self.context[name] = collector
        collector.setSiteManager(LocalSiteManager(collector))
        self.request.response.redirect(".")


class TicketCollectorMainView(form.DisplayForm):

    form_fields = form.Fields(ICollector)

    template = ViewPageTemplateFile("collectormain.pt")

    def getTickets(self):
        tickets = []
        for ticket in self.context.values():
            tickets.append({'url': ticket.number+"/@@index",
                            'summary': ticket.summary})
        return tickets


class AddTicket(form.AddForm):

    form_fields = form.Fields(ITicket)

    def createAndAdd(self, data):
        number = data['number']
        summary = data['summary']
        ticket = Ticket()
        ticket.number = number
        ticket.summary = summary
        self.context[number] = ticket
        self.request.response.redirect('.')

class TicketMainView(form.DisplayForm):

    form_fields = form.Fields(ITicket)

    template = ViewPageTemplateFile("ticketmain.pt")


class AddComment(form.AddForm):

    form_fields = form.Fields(IComment)

    def createAndAdd(self, data):
        body = data['body']
        comment = Comment()
        comment.body = body
        namechooser = INameChooser(self.context)
        number = namechooser.chooseName('c', comment)
        self.context[number] = comment
        self.request.response.redirect('.')

